diff -Nrc2 fontutils-0.5/gsrenderfont/writefont.PS fontutils-0.6/gsrenderfont/writefont.PS
*** fontutils-0.5/gsrenderfont/writefont.PS	Fri Aug 21 16:15:19 1992
--- fontutils-0.6/gsrenderfont/writefont.PS	Sat Oct 24 05:00:24 1992
***************
*** 17,23 ****
  % Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
! % Make a local environment.
! % 
! 100 dict begin
  
  /verbose false def
--- 17,21 ----
  % Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
! 100 dict begin % our local environment
  
  /verbose false def
***************
*** 47,66 ****
  
  
- % Leaves the concatenation of two string arguments on the stack.
- % 
- /concat-strings
- {
-   /string-2 exch def
-   /string-1 exch def	
-   /after-string-1 string-1 length def
-   /answer-string-length string-1 length string-2 length add def
-   /answer-string answer-string-length string def
-   string-1 answer-string copy pop
-   answer-string after-string-1 string-2 putinterval
-   answer-string
- }
- bdef
- 
- 
  % DICT pdict prints all the components in the dictionary in a
  % human-readable way.
--- 45,48 ----
***************
*** 82,86 ****
  
  % Use the real definition of points, not PostScript's.
! /points-per-inch 72.27 def
  /inches-per-point 1 points-per-inch div def
  
--- 64,68 ----
  
  % Use the real definition of points, not PostScript's.
! /points-per-inch 72 def
  /inches-per-point 1 points-per-inch div def
  
***************
*** 90,116 ****
  /points {points-per-pixel mul} bdef	% Use on stuff expressed in pixels.
  /pixels {pixels-per-point mul} bdef	% Use on stuff expressed in points.
- 
- 
  
! % Set the font to `gs-fontname', with encoding `output-encoding'.
! % We cannot rely on the encoding vector only for whether the font defines a
! % certain character; we must also look in the CharStrings.  (The
! % Ghostscript fonts are all StandardEncoding, yet not all characters are
! % defined.)  Unfortunately, this makes this program only work with Type
! % 1 fonts (or Type 3 fonts which store the character definitions in a
! % dictionary named `CharStrings').
  % 
  /set-font
  {
!   gs-fontname cvlit /newfont output-encoding reencode-font
!   /newfont point-size cvi selectfont
    /font-encoding currentfont /Encoding get def
-   /font-charstrings currentfont /CharStrings get def
  }
  bdef
  
! % /OLD-FONTNAME /NEW-FONTNAME NEW-ENCODING defines the font NEW-FONTNAME
! % to be just like OLD-FONTNAME except that the encoding is NEW-ENCODING.
! % Based on the Cookbook encoding vector examples.
  % 
  /reencode-font
--- 72,103 ----
  /points {points-per-pixel mul} bdef	% Use on stuff expressed in pixels.
  /pixels {pixels-per-point mul} bdef	% Use on stuff expressed in points.
  
! % Make a new font whose PostScript name is `/newfont', which is the same
! % as the font with name `gs-fontname' (read from file `input-filename'
! % if necessary) except it has encoding `output-encoding'.
  % 
+ % Set the currentfont to /newfont scaled to `point-size'.
+ % 
  /set-font
  {
!   % Make the new font /newfont.
!   input-filename gs-fontname cvlit /newfont output-encoding reencode-font
! 
!   % Make it the current font (at the requested size).
!   /newfont findfont point-size cvi scalefont setfont
! 
!   % Define the global `font-encoding' for future use.
    /font-encoding currentfont /Encoding get def
  }
  bdef
  
! 
! % (OLD-FILENAME) /OLD-FONTNAME /NEW-FONTNAME NEW-ENCODING reencode-font
! % defines the font NEW-FONTNAME to be like OLD-FONTNAME except that the
! % encoding is NEW-ENCODING.  Based on the Cookbook encoding examples.
! % 
! % We read OLD-FILENAME if /OLD-FONTNAME is unknown to Ghostscript.  We
! % determine this by looking at the dictionary `Fontmap' that Ghostscript
! % defines when it starts up.
  % 
  /reencode-font
***************
*** 118,149 ****
    /new-encoding exch def
    /new-fontname exch def
!   
!   /old-fontdict exch findfont def
    /new-fontdict old-fontdict maxlength dict def
!   
!   % Copy all the elements except FID and Encoding.
    old-fontdict
      {
        exch % now have key at top the stack
!       dup /FID ne  dup /Encoding ne  dup /FontName ne  and and
!         { exch new-fontdict 3 1 roll put }
          { pop pop}
        ifelse
      }
    forall
!   
!   % Install the new Encoding and FontName.
!   new-fontdict /Encoding new-encoding put
!   new-fontdict /FontName new-fontname put
    
    % Define the font.
    new-fontname new-fontdict definefont pop
  }
  bdef
  
  
  
  
! % FILENAME parse-encoding-file tries to read the encoding file
  % `FILENAME.enc'.  If the file can't be found, we quit.  Otherwise, we
  % parse it into an encoding vector and return that on the stack.
--- 105,333 ----
    /new-encoding exch def
    /new-fontname exch def
!   /old-fontname exch def
!   /old-filename exch def
! 
!   % If OLD-FONTNAME is not in `Fontmap', read OLD-FILENAME.
!   Fontmap old-fontname cvn known  not
!     { (Reading `) old-filename concatstrings ('...) concatstrings vreport
!       old-filename run
! 
!       % If reading OLD-FILENAME didn't define OLD-FONTNAME, complain.
!       FontDirectory old-fontname cvn known  not
!         { (Reading `) =only
!           old-filename =only
!           (' didn't define the font `) =only
!           old-fontname =only
!           ('!) =
!           quit
!         }
!       if
!     }
!   if
! 
!   % Get the old font, and make the dictionary that will be the new font.
!   /old-fontdict old-fontname findfont def
    /new-fontdict old-fontdict maxlength dict def
! 
!   % Copy all the elements except `FID', `Encoding', and `FontName'.
    old-fontdict
      {
        exch % now have key at top the stack
!       dup /FID eq  1 index /Encoding eq  2 index /FontName eq  or or
          { pop pop}
+         { exch new-fontdict 3 1 roll put }
        ifelse
      }
    forall
! 
!   % But if NEW-ENCODING is this sentinel value, we copy the existing
!   % encoding vector.
!   % 
!   new-encoding (/encoding-from-input) eq
!     {
!       /new-encoding old-fontdict /Encoding get 256 array copy def
!     }
!   if
    
+   % Get another encoding array, this one a subset of NEW-ENCODING, which
+   % contains only those characters that are actually present in the font
+   % -- sometimes the encoding vectors lie.
+   % 
+   new-fontdict new-encoding encoding-chars-present
+   /ok-encoding exch def
+ 
+   % Install the new Encoding and FontName.  The 10-character limit on
+   % the FontName is not serious, since we are the ones who specify it
+   % (in fact, new-fontname is the name `/newfont').
+   new-fontdict /Encoding ok-encoding put
+   new-fontdict /FontName new-fontname 10 string cvs put
+ 
    % Define the font.
    new-fontname new-fontdict definefont pop
  }
+ bdef % reencode-font
+ 
+ 
+ % FONT-DICT ENCODING encoding-chars-present => NEW-ENCODING returns an
+ % encoding vector contain all and only those characters which are
+ % present in both the font represented by FONT-DICT (which lacks an
+ % Encoding entry) and ENCODING.
+ % 
+ % We have to use different algorithms for Type 1 and Type 3 fonts.
+ % 
+ /encoding-chars-present
+ {
+   /font-type 2 index /FontType get def
+   
+   font-type 1 eq
+     { encoding-chars-present-1 }
+     { encoding-chars-present-3 }
+   ifelse
+ }
+ bdef % encoding-chars-present
+ 
+ 
+ % (See encoding-chars-present).  For Type 1 fonts, we can just look in
+ % the CharStrings entry (which is required) of FONT-DICT.
+ % 
+ /encoding-chars-present-1
+ {
+   /orig-encoding exch def
+   /font-dict exch def
+   
+   /font-charstrings font-dict /CharStrings get def
+   
+   /new-encoding 256 array def
+   /charcode 0 def
+   
+   % For each element in the old vector, see if it's in `CharStrings'.
+     orig-encoding
+     {   font-charstrings 1 index known
+         { new-encoding charcode 3 -1 roll put }
+         { new-encoding charcode /.notdef put  pop }
+       ifelse
+       /charcode incr
+     }
+   forall
+   
+   % Return the new vector.
+   new-encoding
+ }
+ bdef
+ 
+ 
+ % (See encoding-chars-present).  For Type 3 fonts, the character
+ % definitions might be in a dictionary named anything at all.  Heck,
+ % there might not even be a dictionary.  So the best I can think of is
+ % to try to render each character; if it succeeds, we'll say it's
+ % present, and if it fails, we'll omit it.
+ % 
+ % We change the current font to be the one specified by FONT-DICT.
+ % (Since we're going to change fonts again right after we return,
+ % there's no point in saving and restoring.)
+ % 
+ /encoding-chars-present-3
+ {
+   /orig-encoding exch def
+   /font-dict exch def
+   
+   /new-encoding 256 array def
+   
+   % Set up the current font.
+   font-dict orig-encoding type3-setfont
+   
+   % Have to have a current point for `show' to work.
+   % 
+   0 0 moveto
+   
+   % For each element in the old vector, see if we can render it.
+   0 1 255
+     { dup type3-render-p
+         % Push the name we will put in the new vector.
+         { orig-encoding 1 index  get }
+         { /.notdef }
+       ifelse
+ 
+       % Now have charcode and charname on the stack.
+       new-encoding 3 1 roll put
+     }
+   for
+   
+   % Return the new vector.
+   new-encoding
+ }
  bdef
  
  
+ % FONT-DICT ENCODING type3-setfont sets the current font to be the one
+ % represented by FONT-DICT.  We have to set up the encoding vector and
+ % do the definefont ourselves.
+ % 
+ /type3-setfont
+ {
+   /test-encoding exch def
+   /font-dict exch def
+   
+   % Use our new encoding in the test font.
+   font-dict /Encoding test-encoding put
+   
+   % Have to copy the dictionary explicitly, else it will become readonly
+   % and we won't be able to change the encoding for real later.
+   % 
+   font-dict dup maxlength dict copy
+   /type3-testfont exch definefont setfont
+ }
+ bdef
+ 
+ 
+ % CHARCODE type3-render-p => bool returns true if rendering CHARCODE
+ % does not produce an error.  We assume the current font is set to the
+ % right thing.
+ % 
+ /type3-render-p
+ {
+   /char exch def
+   put-char-in-buffer
  
+   % If the BuildChar fails, make sure no junk is left on the operand or
+   % dictionary stacks.
+   countdictstack
+   mark
+   
+   % Render the character
+   { char-buffer show } stopped not
+   
+   % Since we need to clear the operand stack, we have to save the
+   % result.  But since we're going to clear the dictionary stack also,
+   % we have to explicitly use our dictionary.
+   envGSRF /ok 3 -1 roll put
+   
+   cleartomark
+     {
+       dup countdictstack eq { exit } if
+       end
+     }
+   loop
+   pop % The original `countdictstack' value.
+   
+   % Return whether or not we succeeded.
+   ok
+ }
+ bdef
  
! % ENCODING-NAME find-encoding ENCODING reads the encoding file
! % `ENCODING-NAME.enc' unless ENCODING-NAME is a sentinel value, in which
! % case we just return it.
! % 
! /find-encoding
! {
!   dup (/encoding-from-input) eq not
!     { parse-encoding-file }
!   if
! }
! bdef
! 
! 
! % (FILENAME) parse-encoding-file tries to read the encoding file
  % `FILENAME.enc'.  If the file can't be found, we quit.  Otherwise, we
  % parse it into an encoding vector and return that on the stack.
***************
*** 159,163 ****
    
    % Ignore the coding scheme (assumption here that the .enc file does
!   % not have zero or one non-blank non-comment lines):
    encoding-line pop
  
--- 343,348 ----
    
    % Ignore the coding scheme (assumption here that the .enc file does
!   % not have zero or one non-blank non-comment lines, i.e., is empty or
!   % just a comment):
    encoding-line pop
  
***************
*** 176,181 ****
        put
        
!       % Increment /charcode.
!       /charcode charcode 1 add def
      }
    loop
--- 361,366 ----
        put
        
!       % We're on the next character code.
!       /charcode incr
      }
    loop
***************
*** 201,205 ****
  /open-encoding-file
  {
!   (.enc) concat-strings
    findlibfile
      { exch pop /encodingfile exch def }
--- 386,390 ----
  /open-encoding-file
  {
!   (.enc) concatstrings
    findlibfile
      { exch pop /encodingfile exch def }
***************
*** 214,217 ****
--- 399,404 ----
  % returns the first token on the line (i.e., a name).
  % 
+ % Sorry about this hard limit, but I don't want to program variable
+ % strings in PostScript.
  /line-buffer 1000 string def
  
***************
*** 232,239 ****
    loop
  }
! bdef
! 
! 
! 
  
  % Expects a character code on the stack.  Sets /char to that integer,
--- 419,423 ----
    loop
  }
! bdef % encoding-line
  
  % Expects a character code on the stack.  Sets /char to that integer,
***************
*** 245,279 ****
     /char exch def
     /char-name font-encoding char get def
-    % All-blank characters like space wreak havoc with the bbcount and
-    % imagetofont algorithms, so don't output those.
-    /char-in-font
-      char-name /.notdef ne
-      char-name /space ne
-      and
-      font-charstrings char-name known
-      and
-    def
- }
- bdef
  
! 
! % Since we ignored space characters in `set-char-variables' (just
! % above), here is a routine to write the space's charcode to a file.
! % We are passed the file on the stack.
! % 
! /number-buffer 20 string def
! %
! /output-space-char
! {
!   0 1 255 { dup font-encoding exch get /space eq { exit } { pop } ifelse } for
!   dup type (integertype) eq % It's an integer if we found it, a space if not.
!     { number-buffer cvs
!       1 index exch % get the file
!       writestring
!       (\n) writestring
!     }
!   if
  }
! bdef % output-space-char
  
  
--- 429,437 ----
     /char exch def
     /char-name font-encoding char get def
  
!    % There's no point in outputting .notdef.
!    /char-in-font  char-name /.notdef ne  def
  }
! bdef
  
  
***************
*** 296,299 ****
--- 454,458 ----
      newpath
      0 0 moveto
+ 
      char-buffer true charpath      
      flattenpath
***************
*** 320,345 ****
    grestore
  }
! bdef
! 
! % Expects a label string.
! % 
! /print-char-dimensions
! {
!   /label exch def
!   verbose 
!     {() = label =
!      char-buffer (char: ) =only = 
!      char-height (char-height: ) =only =
!      char-depth (char-depth: ) =only =
!      char-tall (char-tall: ) =only =
!      char-stringwidth (char-stringwidth: ) =only =
!      char-width (char-width: ) =only =
!      char-left-sidebearing (char-left-sidebearing: ) =only =
!      char-right-sidebearing (char-right-sidebearing: ) =only =
!      flush
!     }
!   if
! }
! bdef % print-char-dimensions
  
  % If the char is defined in the font, show it on on a line by itself, ni
--- 479,483 ----
    grestore
  }
! bdef % find-char-dimensions-in-pixels
  
  % If the char is defined in the font, show it on on a line by itself, ni
***************
*** 355,359 ****
        put-char-in-buffer
        find-char-dimensions-in-pixels
!       %%char-name print-char-dimensions
  
        % If the lsb is negative, the character protrudes to the left of
--- 493,497 ----
        put-char-in-buffer
        find-char-dimensions-in-pixels
!       %%char-name print-char-dimensions %%
  
        % If the lsb is negative, the character protrudes to the left of
***************
*** 362,366 ****
            char-left-sidebearing 0 lt { char-left-sidebearing neg } { 0 } ifelse
          points
!         char-height points neg
        rmoveto
  
--- 500,504 ----
            char-left-sidebearing 0 lt { char-left-sidebearing neg } { 0 } ifelse
          points
!         char-height ceiling points neg
        rmoveto
  
***************
*** 373,377 ****
        % Leave enough blank rows to fill up the max-char-tall-in-pixels
        % space.  This will always be more than the descender.
!       0  max-char-tall-in-pixels char-height sub points neg  rmoveto
      }
    if
--- 511,515 ----
        % Leave enough blank rows to fill up the max-char-tall-in-pixels
        % space.  This will always be more than the descender.
!       0  max-char-tall-in-pixels char-height ceiling sub points neg  rmoveto
      }
    if
***************
*** 378,381 ****
--- 516,541 ----
  }
  bdef % show-char
+ 
+ 
+ % Expects a label string.
+ % 
+ /print-char-dimensions
+ {
+   /label exch def
+   verbose 
+     {() = label =
+      char-buffer (char: ) =only = 
+      char-height (char-height: ) =only =
+      char-depth (char-depth: ) =only =
+      char-tall (char-tall: ) =only =
+      char-stringwidth (char-stringwidth: ) =only =
+      char-width (char-width: ) =only =
+      char-left-sidebearing (char-left-sidebearing: ) =only =
+      char-right-sidebearing (char-right-sidebearing: ) =only =
+      flush
+     }
+   if
+ }
+ bdef % print-char-dimensions
  
  % IFI stuff.
***************
*** 396,400 ****
  /baseline-adjustment
  {
!   char-depth round cvi 1 sub output-buffer cvs
  }
  bdef
--- 556,560 ----
  /baseline-adjustment
  {
!   char-depth round cvi 1 sub neg output-buffer cvs
  }
  bdef
***************
*** 414,420 ****
  {
    char-left-sidebearing round output-buffer cvs
!   ( ) concat-strings
    char-right-sidebearing round output-buffer cvs 
!   concat-strings
  }
  bdef
--- 574,580 ----
  {
    char-left-sidebearing round output-buffer cvs
!   ( ) concatstrings
    char-right-sidebearing round output-buffer cvs 
!   concatstrings
  }
  bdef
***************
*** 501,514 ****
          {
            /extant-char-count incr
!           
            put-char-in-buffer
            find-char-dimensions-in-pixels
!           
            % The set width might be smaller than the bounding box if we
            % have negative side bearings.
            char-stringwidth char-width max
!           /max-char-width-in-pixels exch  max=
            
!           /max-char-tall-in-pixels char-tall max=
          }
        if
--- 661,677 ----
          {
            /extant-char-count incr
! 
            put-char-in-buffer
            find-char-dimensions-in-pixels
! 
            % The set width might be smaller than the bounding box if we
            % have negative side bearings.
            char-stringwidth char-width max
!           /max-char-width-in-pixels exch max=
            
!           % Accents (for example) might have a positive depth, and thus
!           % the height will be less than the height + depth, and what we
!           % want is the largest y coordinate.
!           /max-char-tall-in-pixels char-tall char-height max max=
          }
        if
***************
*** 516,522 ****
    for
  
!   % We also want to have at least a couple blank rows between each character.
!   % The constant here is also used in bbcount's pbm-reading routines.
!   /max-char-tall-in-pixels max-char-tall-in-pixels 4 add ceiling def
    
    verbose
--- 679,687 ----
    for
  
!   % We also want to have some blank rows between characters.  The
!   % constant here is also used in bbcount's pbm-reading routines.
!   /max-char-tall-in-pixels
!     max-char-tall-in-pixels ceiling  4 add  cvi
!   def
    
    verbose
***************
*** 564,569 ****
  }
  bdef % compute-final-device-dimens
- 
- 
  
  % make-gsfont, the main program.
--- 729,732 ----
***************
*** 570,578 ****
  
  % Arguments:
! %   gs-fontname (e.g., Times-Roman---no slash in front)
! %   font-basename (e.g., phvr -- to get hvr.pbm and hvr.ifi)
! %   point-size
! %   pixels-per-inch (e.g., 300 -- can't have nonsquare pixels)
! %   output-encoding-filename (e.g., textext -- to find the .enc file)
  % 
  /make-gsfont
--- 733,744 ----
  
  % Arguments:
! %   gs-fontname		(e.g., Times-Roman -- no slash in front)
! %   input-filename	(e.g., ptmr -- unused if the font is in Fontmap)
! %   output-filename	(e.g., ptmr -- to get ptmr.pbm and ptmr.ifi)
! %   point-size		(e.g., 10 -- in PostScript points)
! %   pixels-per-inch	(e.g., 300 -- can't have nonsquare pixels)
! %   encoding-filename	(e.g., textext -- to find .enc file)
! % 
! % (Except `encoding-filename' might be a sentinel value, not a filename.)
  % 
  /make-gsfont
***************
*** 579,597 ****
  {
    /gs-fontname exch def
!   /font-basename exch def
    /point-size exch cvi def
    /pixels-per-inch exch cvi def
!   /output-encoding-filename exch def
  
!   % Look for the file `output-encoding-name.enc' and parse it,
    % returning an encoding dictionary.
    % 
!     (Parsing encoding file ) output-encoding-filename concat-strings
!     (.enc...) concat-strings
    vreport
!   /output-encoding output-encoding-filename parse-encoding-file def
  
!   % Now that we know the encoding, we can make the font we're going to
!   % render the current font.
    % 
    (Reencoding and setting font...) vreport
--- 745,764 ----
  {
    /gs-fontname exch def
!   /input-filename exch def
!   /output-filename exch def
    /point-size exch cvi def
    /pixels-per-inch exch cvi def
!   /encoding-filename exch def
  
!   % Look for the file `encoding-filename.enc' and parse it,
    % returning an encoding dictionary.
    % 
!     (Using encoding `) encoding-filename concatstrings
!     (' for output...) concatstrings
    vreport
!   /output-encoding encoding-filename find-encoding def
  
!   % Now that we know the output encoding, we can make the font we're
!   % going to render the current font.
    % 
    (Reencoding and setting font...) vreport
***************
*** 622,626 ****
  
    (Writing PBM file...) vreport
!   /pbm-filename font-basename (.pbm) concat-strings def
    /pbm-file pbm-filename (w) file def
    pbm-file currentdevice writeppmfile
--- 789,793 ----
  
    (Writing PBM file...) vreport
!   /pbm-filename output-filename (.pbm) concatstrings def
    /pbm-file pbm-filename (w) file def
    pbm-file currentdevice writeppmfile
***************
*** 628,632 ****
  
    (Writing BFI file...) vreport
!   /bfi-filename font-basename (.bfi) concat-strings def
    /bfi-file bfi-filename (w) file def
    bfi-file extant-char-count output-buffer cvs writestring
--- 795,799 ----
  
    (Writing BFI file...) vreport
!   /bfi-filename output-filename (.bfi) concatstrings def
    /bfi-file bfi-filename (w) file def
    bfi-file extant-char-count output-buffer cvs writestring
***************
*** 634,642 ****
    bfi-file max-char-tall-in-pixels output-buffer cvs writestring
    bfi-file (\n) writestring
-   bfi-file output-space-char
    bfi-file closefile
    
    (Writing XIFI file...) vreport
!   /ifi-filename font-basename (.xifi) concat-strings def
    /ifi-file ifi-filename (w) file def
    0 1 255 { output-char-info } for
--- 801,808 ----
    bfi-file max-char-tall-in-pixels output-buffer cvs writestring
    bfi-file (\n) writestring
    bfi-file closefile
    
    (Writing XIFI file...) vreport
!   /ifi-filename output-filename (.xifi) concatstrings def
    /ifi-file ifi-filename (w) file def
    0 1 255 { output-char-info } for
diff -Nrc2 fontutils-0.5/imageto/.gdbinit fontutils-0.6/imageto/.gdbinit
*** fontutils-0.5/imageto/.gdbinit	Sun Aug 16 17:55:30 1992
--- fontutils-0.6/imageto/.gdbinit	Fri Oct 23 10:24:08 1992
***************
*** 109,110 ****
--- 109,116 ----
  #  ../ourfonts/garamond/r/percent/perc.img
  
+ # finding out about bb info with atlas (20 Sep 92)
+ #set args -verbose -print-guidelines -print-clean-info -nchars=26 \
+ #-baselines=121 \
+ #-info=$garamond/atlas/first -encoding=gnulatin $garamond/atlas/ggmr.img
+ 
+ set args -verbose ../gsrenderfont/cmr.pbm -dpi=300 -enc=dvips
diff -Nrc2 fontutils-0.5/imageto/ChangeLog fontutils-0.6/imageto/ChangeLog
*** fontutils-0.5/imageto/ChangeLog	Thu Sep  3 09:30:54 1992
--- fontutils-0.6/imageto/ChangeLog	Tue Oct 27 13:02:50 1992
***************
*** 1,2 ****
--- 1,118 ----
+ Tue Oct 27 13:02:04 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* Version 0.6.
+ 
+ Sat Oct 24 05:13:02 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* ifi.c (read_ifi_file): Just do successive character codes if we
+ 	don't have an encoding file.
+         * main.c (USAGE): Change doc.
+ 
+ Fri Oct 23 10:43:46 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* out-chars.c (output_chars): Free the bounding box list we construct.
+ 
+ 	* out-chars.c (output_chars): If the IFI struct says no bounding
+ 	boxes, don't read any of the bitmap, and reconsider the current bb.
+ 
+ Tue Oct 20 17:17:26 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* GNUmakefile (install): Make the second arg a file, not a directory.
+ 
+ Fri Oct 16 15:40:53 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* out-epsf.c: Doc fix.
+ 
+ Mon Oct  5 09:31:30 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* main.c (read_command_line): Make -print-clean-info imply -verbose.
+         (main): Remove now-redundant test for `print_clean_info'.
+ 
+ 	* out-chars.c (write_image_chars): Only report "+" if we have to
+ 	keep reading vertically, not horizontally.
+         (do_image_line): Remove the report from here.
+ 
+ Sun Oct  4 08:59:55 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* out-chars.c (write_image_chars): Don't keep adding to
+ 	`row_height' for appended image rows, just assign.
+ 
+ 	* main.c (main): Test for zero resolution here.
+         (set_input_format): Not here.
+ 
+ 	* out-chars.c (clean_threshold): Remove.
+         * out-chars.h: Likewise.
+         * main.c (USAGE, read_command_line): And here.
+ 
+ 	* out-chars.c (bb_equal_p): New fn.
+ 
+ 	* out-chars.c (offset_bb_list): Function moved here from bb-outline.c.
+ 
+ 	* out-chars.c (clean_bitmap): Rewrite to take a list of known
+ 	boxes, and remove those that aren't in the list.
+         (output_chars): Only call `clean_bitmap' once, after we've
+         combined everything.
+         (image_to_bitmap_bbs): New fn.
+ 
+ Sat Oct  3 13:54:39 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* out-chars.c (write_image_chars): Don't abort if the image ends
+ 	prematurely, just give a warning and return.
+ 
+ 	* out-chars.c (OUTPUT_CHAR_P): New macro.
+         (output_chars): Use it, instead of repeating the same expr several
+         times.
+ 
+ Fri Oct  2 16:14:03 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* out-chars.[ch]: New files constructed from main.[ch].
+         * main.c: Include out-chars.h.
+ 
+ 	* extract.c (REPORT_SCANLINE): use REPORT.
+ 
+ 	* main.c (-info-filename): remove this option.
+ 
+ 	* {epsf,strips}.[ch]: Rename to out-*.
+ 	* GNUmakefile (c_and_h): Likewise.
+ 
+ 	* ifi.[ch]: New files constructed from image-char.[ch] and main.c.
+         * main.c: include ifi.h.
+         (extract_chars): Change call to read_ifi_file.
+         * GNUmakefile (c_and_h): add `ifi', remove `image-char'.
+ 
+ Mon Sep 28 11:11:59 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+ 	* main.c: change `fprintf (stderr's to use REPORT*.
+ 
+ 	* main.c (clean_bitmap): print the size of the bounding box being
+ 	cleaned, not that of the enclosing character.  (halvers@sol.crd.ge.com)
+ 
+ Tue Sep 22 13:01:54 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+         * main.c (read_ifi_file): call make_suffix to make the default IFI
+           filename, instead of appending to the root.
+         (input_rootname): remove.
+         (main): don't assign to input_rootname; just set output_name to
+           the fn call.
+         (input_name): new static.
+ 
+         * main.c (clean_bitmap): if clean_threshold is 1.0, do nothing;
+           else only clean if the gray value is > threshold, not >=.
+ 
+         * main.c: make diagnostic messages consistent.
+ 
+         * main.c (do_image_line): set `bb_offset' to just the width
+           of the previous bb, since we're already incorporating the
+           interbb whitespace in the second bb.
+ 
+ Mon Sep 21 10:32:07 1992  Karl Berry  (karl@cs.umb.edu)
+ 
+         * main.c (read_command_line): new option -ifi-file, a synonym for
+           -info-file.
+         (USAGE): document it.
+ 
+         * main.c (set_input_format): don't call strcmp on NULL if the
+           input filename lacks an extension.
+ 
  Thu Sep  3 09:30:54 1992  Karl Berry  (karl@hayley)
  
diff -Nrc2 fontutils-0.5/imageto/GNUmakefile fontutils-0.6/imageto/GNUmakefile
*** fontutils-0.5/imageto/GNUmakefile	Sat Aug 29 16:14:02 1992
--- fontutils-0.6/imageto/GNUmakefile	Tue Oct 20 17:17:53 1992
***************
*** 19,23 ****
  program = imageto
  
! c_and_h = bitmap2 epsf extract image-char input-img input-pbm main strips
  h_only = image-header
  c_only = version
--- 19,24 ----
  program = imageto
  
! c_and_h = bitmap2 extract ifi input-img input-pbm main \
!           out-chars out-epsf out-strips
  h_only = image-header
  c_only = version
***************
*** 32,36 ****
  
  install::
! 	$(INSTALL_DATA) strips.tex $(texinputdir)
  
  include M.depend
--- 33,37 ----
  
  install::
! 	$(INSTALL_DATA) strips.tex $(texinputdir)/strips.tex
  
  include M.depend
